//+------------------------------------------------------------------+
//|                                                     Patient1.mq4 |
//|                                       Copyright  2006, Aaragorn |
//|                   http://www.forex-tsd.com/members/aaragorn.html |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Aaragorn"
#property link      "http://www.forex-tsd.com/members/aaragorn.html"
//
// As always I suggest you do enough testing in demos, that you feel comfortable
// knowing AND UNDERSTANDING the risks of using this EA, before you do anything in
// your live accounts. Its use is strictly "AT YOUR OWN RISK". I ask that those who do 
// eventually use this and make money send me 33% of the net monthly gains which result.
// Made payable to: Kelly C.
// Sent to:
// Aaragorn's forex
// P.O. Box 553
// Springville, Utah 84663 
//
/* System specific */
//
string SystemName = "Patient 1";
double version = 1;
//extern int MagicNumber=135797531;    // Magic Number -- change for every pair traded
#include <stdlib.mqh>

//---- User defined indicator parameters
extern bool Usefilewrite = true;
extern string entry_indicators    =            "Entry Indicator Variables                ";
extern double AllShift            =        1; // zero uses the current forming bar, 1 uses the first completed bar
extern int    Trigger_MA          =        1; // x MUST be interger > 0 this is the averaging period of the trigger moving average
extern double MinimumADX          =        8;
extern bool   UseRunAwayEnterance =     true;
extern int    RAELevel            =        7; // sets number of pips off Envelope to allow entrance
extern string Envelope_Parameters =            "Envelope_Parameters";
extern double EnvelopeAP          =       10; // this is the averaging period of the MA envelope
extern double Envelope_Deviation  =     0.06; // All variables < zero must have 0 to the left of the decimal to compile properly //0.47 works for hours//0.047 on 30M

extern string ADX_Parameters      =            "ADX_Parameters";
extern double ADXPeriod           =       10;
extern double ma_shift            =        0;
extern string Order_Management    =             "Order_Management"; 
extern int    MaxTradesAllowed    =        1;//max 16 works
extern double TakeProfit          =       42;
extern double ReenterTPgap        =        2;
extern int    SlipPage            =        0;
extern string                 Lot_Parameters = "Lot_Parameters";
extern bool                    UseStaticLots = true;
extern double                     StaticLots = 0; // overrides all other lot calculations
extern double                        MaxLots = 0.6; // lots smaller than 1 must have "0.x", don't forget the zero left of the decimal
extern double                 LotAccelerator = 0.11; // degree of lot acceleration

 
extern string Dynamic_Trailing_Stop_Settings = "Dynamic Trailing Stop Settings";
extern bool               EnableTrailingStop = true; // Enable Dynamic Trailing Stop
extern int                    TrailATRPeriod = 7;
extern double             TrailingStopFactor = 1.45;
extern string                  Auto_StopLoss = "Auto StopLoss";
extern double                  StopLossIndex = 2.5;
extern bool                AutoStopLossIndex = true;
extern string                Manual_StopLoss = "Manual overrides Auto StopLoss unless = 0";
extern double                 ManualStopLoss = 0;  //0 allows for auto stop loss
extern double                      StopLevel = 0;
extern string                Discretionaries = "Discretionaries";
extern bool                    UseDiscretion = false;
extern int         MajorTrendAveragingPeriod = 10;
extern string      Additional_User_Functions = "Additional User Functions";
extern bool                  UseHardReverser = false;
extern bool                        UseAlerts = false; //Gives Audio and pop up Alert when Patient1 enters a position
//extern bool         DynamicTrailManualTrades = false; //Allows Patient1 Dynamic Trailing Stop to Manage Manually Opened Orders on the same currency pair
extern bool                    UseExitMarket = true;//must be on for next 4 functions to work 
extern bool                    UseEnhancedTP = true;
extern bool                       UseReenter = true;
extern bool               UseModifiedEntries = true;
extern bool                    UseRevEnvelop = false;
extern bool                        UseRevADX = false;
extern bool                       UseDevStop = false;
extern bool                     UseStopLossClose = true;
extern int MagicNumber=135797531;    // Magic Number -- change for every pair traded        







//---- entry logic only indicator variables
double Cnow=0,Unow=0,Lnow=0,ADXnow=0,DIMnow=0,DIPnow=0;
double Closing1=0,UpperE1=0,LowerE1=0;
double Closing2=0,UpperE2=0,LowerE2=0;
double Closing3=0,UpperE3=0,LowerE3=0;
double Closing4=0,UpperE4=0,LowerE4=0;
double ADX1=0,DIminus1=0,DIplus1=0;
double ADX2=0,DIminus2=0,DIplus2=0;
double ADX3=0,DIminus3=0,DIplus3=0;

//---- indicator variables
double MA=0,MA1=0,EMAm1=0,MA100=0,MA1002=0,UpperEc=0,MAEVP=0,MAEVP2=0,LowerEc=0,UpperE=0,LowerE=0;
double ADX=0,DIminus=0,DIplus=0,high1=0,low1=0;



//----  variables for storing market information         
double ModeSpread=0,ModeStopLevel=0,ModePoint=0,Disperce=0;

//---- order management variables
int ticket, total, cnt, handle;
double  StopLoss=0,Lots=0,TSF=0;

//---- order control variables
bool OpenLong = false;
bool OpenShort = false;
bool BlockSell = false;
bool BlockBuy = false;
bool SkipRAE = false;
bool ControlModlong = false;

// Dynamic Trailing stop (TS) global variables
double PrevBuyStop=0,BuyStop=0;
double PrevSellStop=0,SellStop=0,TrailingStop=0;

#define DECISION_BUY 1
#define DECISION_SELL 0
#define DECISION_UNKNOWN -1
//----
double ValuePeriod = 1;                      // Step of period in minutes
double ValuePeriodPrev = 1;
int FoundOpenedOrder = false;
bool DisablePipsator = false;
double BidPrev = 0;
double AskPrev = 0;
extern double ValuesPeriodCount = 7;
// Variables for evaluating the quality of the simulation
double BuyPossibilityQuality;
double SellPossibilityQuality;
double UndefinedPossibilityQuality;
//double BuyPossibilityQualityMid;
double PossibilityQuality;
double QualityMax = 0;
//----
double BuySucPossibilityQuality;
double SellSucPossibilityQuality;
double UndefinedSucPossibilityQuality;
double PossibilitySucQuality;
//----
double ModelingPeriod;                       // Period of simulation in the minutes
double ModelingBars;                         // Quantity of steps in the period
//----
double Spread;                               // Spread
double Decision;
double DecisionValue;
double PrevDecisionValue;
//----
double BuyPossibility;
double SellPossibility;
double UndefinedPossibility;
double BuyPossibilityPrev;
double SellPossibilityPrev;
double UndefinedPossibilityPrev;
//----
double BuySucPossibilityMid;                 // Average probability of the successful purchase
double SellSucPossibilityMid;                // Average probability of successful sale
double UndefinedSucPossibilityMid;           // Average successful probability of the indeterminate state
//----
double SellSucPossibilityCount;              // Count of probabilities of successful sale
double BuySucPossibilityCount;               // Count of probabilities of the successful purchase
double UndefinedSucPossibilityCount;         // Count of probabilities of the indeterminate state
//----
double BuyPossibilityMid;                    // Average probability of the purchase
double SellPossibilityMid;                   // Average probability of sale
double UndefinedPossibilityMid;              // Average probability of the indeterminate state
//----
double BuyPossibilityCount;                  // Count of probabilities of purchase
double SellPossibilityCount;                 // Count of probabilities of sale
double UndefinedPossibilityCount;            // Count of probabilities of the indeterminate state
//----





//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
    ModelingPeriod = ValuePeriod * ValuesPeriodCount;              // Period of simulation in minutes
   if (ValuePeriod != 0 )
       ModelingBars = ModelingPeriod / ValuePeriod;               // Quantity of steps in the period
   CalculateSpread();  
//----
   return(0);
  }  
//+------------------------------------------------------------------+
//| We calculate the actual value of spread (returned functions on   |
//| the market can give the incorrect actual value of spread if the  |
//| broker varies the value of spread                                |
//+------------------------------------------------------------------+

int CalculateSpread()
  {
   Spread = Ask - Bid;
   return (0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   string comment_line="";
   comment_line = StringConcatenate("Spread = ",Ask-Bid);
   Comment(comment_line);
   //----we establish the Indicators
      //market exit only
      EMAm1 = iMA(NULL,PERIOD_M1,Trigger_MA,0,MODE_SMA,0,0);
      UpperEc = iEnvelopes(NULL,0,EnvelopeAP,MODE_SMA,ma_shift,PRICE_CLOSE,Envelope_Deviation,MODE_UPPER,0);
      MAEVP = iMA(NULL,0,EnvelopeAP,0,MODE_SMA,0,0);
      MAEVP2 = iMA(NULL,0,EnvelopeAP,0,MODE_SMA,0,2);//used for reentry screening only
      LowerEc = iEnvelopes(NULL,0,EnvelopeAP,MODE_SMA,ma_shift,PRICE_CLOSE,Envelope_Deviation,MODE_LOWER,0);
      high1 = iHigh(NULL,0,1);
      low1 = iLow(NULL,0,1);
      
   //----we establish the Indicators for current and previous two Bars
   
      //---- current bar when AllShift = 1
      Cnow  =  iMA(NULL,0,Trigger_MA,0,MODE_SMA,0,AllShift-1);
      Unow  =  iEnvelopes(NULL,0,EnvelopeAP,MODE_SMA,ma_shift,PRICE_CLOSE,Envelope_Deviation,MODE_UPPER,AllShift-1);
      Lnow  =  iEnvelopes(NULL,0,EnvelopeAP,MODE_SMA,ma_shift,PRICE_CLOSE,Envelope_Deviation,MODE_LOWER,AllShift-1);
      ADXnow= iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MAIN,AllShift-1);
      DIPnow= iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,AllShift-1);
      DIMnow=  iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,AllShift-1);  
      MA100 = iMA(NULL,0,100,0,MODE_SMA,0,AllShift-1);
      
      //---- shifted previous 1 bar when AllShift = 1
      Closing1 = iMA(NULL,0,Trigger_MA,0,MODE_SMA,0,AllShift);
      UpperE1 = iEnvelopes(NULL,0,EnvelopeAP,MODE_SMA,ma_shift,PRICE_CLOSE,Envelope_Deviation,MODE_UPPER,AllShift);
      LowerE1 = iEnvelopes(NULL,0,EnvelopeAP,MODE_SMA,ma_shift,PRICE_CLOSE,Envelope_Deviation,MODE_LOWER,AllShift);
      ADX1 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MAIN,AllShift);
      DIplus1 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,AllShift);
      DIminus1 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,AllShift);   

      //---- shifted previous 2 bars when AllShift = 1
      Closing2 = iMA(NULL,0,Trigger_MA,0,MODE_SMA,0,AllShift+1);
      UpperE2 = iEnvelopes(NULL,0,EnvelopeAP,MODE_SMA,ma_shift,PRICE_CLOSE,Envelope_Deviation,MODE_UPPER,AllShift+1);
      LowerE2 = iEnvelopes(NULL,0,EnvelopeAP,MODE_SMA,ma_shift,PRICE_CLOSE,Envelope_Deviation,MODE_LOWER,AllShift+1);
      ADX2 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MAIN,AllShift+1);
      DIplus2 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,AllShift+1);
      DIminus2 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,AllShift+1);
      MA1002 = iMA(NULL,0,100,0,MODE_SMA,0,AllShift+1);
      
      //---- shifted previous 3 bars when AllShift = 1
      Closing3 = iMA(NULL,0,Trigger_MA,0,MODE_SMA,0,AllShift+2);
      UpperE3 = iEnvelopes(NULL,0,EnvelopeAP,MODE_SMA,ma_shift,PRICE_CLOSE,Envelope_Deviation,MODE_UPPER,AllShift+2);
      LowerE3 = iEnvelopes(NULL,0,EnvelopeAP,MODE_SMA,ma_shift,PRICE_CLOSE,Envelope_Deviation,MODE_LOWER,AllShift+2);
      ADX3 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MAIN,AllShift+2);
      DIplus3 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,AllShift+2);
      DIminus3 = iADX(NULL,0,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,AllShift+2);
          
      //---- shifted previous 4 bars when AllShift = 1
      Closing4 = iMA(NULL,0,Trigger_MA,0,MODE_SMA,0,AllShift+3);
      UpperE4 = iEnvelopes(NULL,0,EnvelopeAP,MODE_SMA,ma_shift,PRICE_CLOSE,Envelope_Deviation,MODE_UPPER,AllShift+3);
      LowerE4 = iEnvelopes(NULL,0,EnvelopeAP,MODE_SMA,ma_shift,PRICE_CLOSE,Envelope_Deviation,MODE_LOWER,AllShift+3);

      //--- we get market information
      ModeSpread = MarketInfo(Symbol(), MODE_SPREAD);
      ModeStopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL);
      ModePoint = MarketInfo(Symbol(), MODE_POINT);
      
    
    
    
      
      CalculateSpread();
      //----we manage any open orders
      //Print("call exit");
      ExitMarket();
      //Print("call trailstop");
      DynamicTrailStop();
      
      //----we define the rules for opening orders 

      OpenLong = false;
      OpenShort = false;  
      
      //standard long    
      if((Closing4 < LowerE4) || (Closing3 < LowerE3) || (Closing2 < LowerE2) || (Closing1 < LowerE1)) 
         {
         //Print(" Close was below envelope sometime in last 4 bars");
         if((DIplus2 > DIminus2) || (DIplus1 > DIminus1))//|| (DIPnow > DIMnow)
            {
            //Print(" DI crossed up in last two bars");
            if((Cnow > Unow)) //(Closing2 > UpperE2) || (Closing1 > UpperE1) ||
               {
               //Print(" Closed above envelop  now>>>>>>>>>potential buy signal");
               if(ADXnow > MinimumADX)   
                  {
                  if(MAEVP > MAEVP2)//always trade with the trend
                     {
                     //Print("long has full compliance");
                     OpenLong = true;
                     SkipRAE = false;
                     ControlModlong = false;
                     //Print("Open long true @ ",TimeHour(CurTime()),"  Minute: ",TimeMinute(CurTime()) );
                     }//if with trend
                  }//if minimum ADX
               }//if MA breaks out over upper envelope
            }//if DI+ crossed up over DI-
         }//if MA is below lower envelope
        
        //modified long 
        
        if(UseModifiedEntries == true)
         {
         if(DIPnow < DIMnow)
            {
            ControlModlong = true;
            }
         if(ControlModlong == true)   
            {
            //Print(" Close was below envelope sometime in last 4 bars");
            if((DIplus2 > DIminus2) || (DIplus1 > DIminus1))//|| (DIPnow > DIMnow)
               {
               //Print(" DI crossed up in last two bars");
               if((Cnow > Unow)) //(Closing2 > UpperE2) || (Closing1 > UpperE1) ||
                  {
                  //Print(" Closed above envelop  now>>>>>>>>>potential buy signal");
                  if(ADXnow > MinimumADX)   
                     {
                     if(MAEVP > MAEVP2)//always trade with the trend
                        {
                        //Print("long has full compliance");
                        OpenLong = true;
                        SkipRAE = false;
                        ControlModlong = false;
                        //Print("Open long true @ ",TimeHour(CurTime()),"  Minute: ",TimeMinute(CurTime()) );
                        }//if with trend
                     }//if minimum ADX
                  }//if MA breaks out over upper envelope
               }//if DI+ crossed up over DI-
            }//if controlmodlong
         }//if usemodifieds
   
      if((Closing4 > UpperE4) || (Closing3 > UpperE3) || (Closing2 > UpperE2) || (Closing1 > UpperE1)) 
         {
         //Print(" Close was above envelop sometime in last 4 bars");
         if((DIplus2 < DIminus2) || (DIplus1 < DIminus1))// || (DIPnow < DIMnow)
            {
            //Print(" DI crossed down in last two bars");          
            if((Cnow < Lnow))//(Closing2 < LowerE2) || (Closing1 < LowerE1) || 
               {
               //Print(" Closed below envelope  now.........potential sell signal");
               if(ADXnow > MinimumADX)   
                  {
                  if(MAEVP < MAEVP2)// always trade with the trend
                     {
                     //Print("short has full compliance");
                     OpenShort = true;
                     SkipRAE = false;
                     //Print("Open short true @ ",TimeHour(CurTime()),"  Minute: ",TimeMinute(CurTime()) );
                     }
                  }
               }//if MA breaks out below lower envelope
            }//if DI- crossed up over DI+
         }//if MA is above the upper envelope
     
      //----we set stop loss and enter the market
      Patient1Decision();
      AutoStopLossIndex();
      CalculateLots();      
      EnterMarket();
      

  return(0);//repeat for next tick
}//int start




//+----------------------------Functions--------------------------------------+
//+------------------------------------------------------------------+
//|  We calculate Lots                            |
//+------------------------------------------------------------------+
double CalculateLots()
{
   Lots = NormalizeDouble(AccountFreeMargin()/(LotAccelerator*1000/0.1),1);
   if(Lots < 0.01) Lots = 0.01;
   if(Lots > MaxLots) Lots = MaxLots;
      if(UseStaticLots)
         {
         if(StaticLots == 0)
            {
            StaticLots = Lots;
            }
         Lots = StaticLots;   
         }
   return (Lots);
}





//+------------------------------------------------------------------+
//| Search for the open orders                                       |
//+------------------------------------------------------------------+

int FindSymbolOrder()
  {
   FoundOpenedOrder = false;
   total = OrdersTotal();
   for(cnt = 0; cnt < total; cnt++)
     {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      // We search for order on our currency
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
         {
           FoundOpenedOrder = True;
           break;
         }
       else
         {
           StopLevel = 0;
           StopLoss = 0;
         }
     }
   return (0);
  }

//+------------------------------------------------------------------+
//| Entrance into the market                                         |
//+------------------------------------------------------------------+

int EnterMarket()
{
   // We limit the number of open orders allowed to enter into the market
   FindSymbolOrder();
   HardReverser();
   total = OrdersTotal();
   if(total < MaxTradesAllowed && FoundOpenedOrder == false)
      {
           // We count the dispersion 
           Disperce = (iHigh(Symbol(), 0, 0) - iLow(Symbol(), 0, 0));
           
           if(OpenShort == true)
               {
               // Calculation of the stoploss
                   if((Ask + BuySucPossibilityMid*StopLossIndex + ModeSpread * Point) < 
                      (Ask + ModeStopLevel* ModePoint+ ModeSpread * Point))
                     {
                       StopLoss = Ask + ModeStopLevel* ModePoint+ ModeSpread * Point + Disperce;
                     }
                   else
                     {
                       if(BuySucPossibilityMid != 0)
                           StopLoss = Ask + BuySucPossibilityMid*StopLossIndex + 
                                      ModeSpread * Point+ Disperce;
                       else
                           StopLoss = Ask + ModeStopLevel* ModePoint+ ModeSpread * Point + 
                                      Disperce;
                     }
                  if(ManualStopLoss > 0) 
                     {
                     StopLoss = Ask + (ManualStopLoss * Point);
                     }  
                  StopLevel = StopLoss;
                  BlockSell = false; 
                  discretion();
                  if(BlockSell == true)
                     {
                       return(0);
                     }    
                  if(UseRunAwayEnterance && SkipRAE == false)       
                    { 
                     if(Bid <= Lnow - RAELevel*Point)//short run away enterance filter
                      {
                        Print("RAE Blocked Short Entrance @: ", Bid," < RAE: ",Lnow - RAELevel*Point,"  Entry: ",Year(),".",Month(),".",Day(),".",Hour(),".",Minute(),".",Seconds());
                        return(0);
                      }
                    } 
                   TSF = TrailingStopFactor;
                   double LL = 0;
                   LL = Low[Lowest(NULL,0,MODE_LOW,64,1)];
                   if(Bid - (12*Point) < LL )
                     {
                        if(DIMnow < 25)
                         {
                         TakeProfit = 12;
                         }
                        if(DIMnow > 25 && MAEVP < MAEVP2)
                         {
                         TakeProfit = 45;
                         TrailingStopFactor = 3;
                         }
                         else
                         {
                         TakeProfit = TakeProfit;
                         TrailingStopFactor = TSF;
                         }  
                      } 
                     else
                     {
                     return(0);
                     }   
                     StopLoss = StopLoss + (4*Point); /////////////////////////////////////kludge very messy
                          
                //---- Open Short Order
                ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, SlipPage, StopLoss, Bid - (TakeProfit * Point), "Order by Patient1", MagicNumber, 0, Green);
                   if(ticket > 0)
                     {
                       if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
                       {
                        OpenShort = false;
                        SkipRAE = false;
                        if (Usefilewrite)
                           {
                              datetime sorderOpen=OrderOpenTime();
                              handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
                              if(handle!=-1)
                                {
                                    FileSeek(handle,0,SEEK_END);
                                    FileWrite(handle," ");
                                    FileWrite(handle," Opened SHORT #: ",OrderTicket()," Order Open Time: ",sorderOpen);
                                    FileWrite(handle,"Lots: ",Lots," Bid: ",Bid," SlipPage: ",SlipPage," StopLoss: ",StopLoss," Take Profit: ",Bid - (TakeProfit * Point)," TrailingStopFactor: ",TrailingStopFactor);
                                    FileWrite(handle,"ADXnow: ",ADXnow," DIPnow: ",DIPnow," DIMnow: ",DIMnow," LL of last 64 bars: ",LL);
                                    FileWrite(handle,"Cnow: ",Cnow," Lnow: ",Lnow," Unow: ",Unow," MAEVP: ",MAEVP," MAEVP2: ",MAEVP2," MA100: ",MA100," MA1002: ",MA1002);
                                    
                                    FileFlush(handle);
	                                 FileClose(handle);
                                }   
                                else
                                 {
                                 int err;
                                 err=GetLastError();
                                 Print("error(",err,"): ",ErrorDescription(err));

                                 return(0);                     
                                 }
                           }//if use file write
                        Print("SHORT OPENED WITH TRAILINGSTOPFACTOR = ",TrailingStopFactor);
                        PrevSellStop = OrderStopLoss();
                        if(UseAlerts==true)
                           {
                           PlaySound("alert.wav");
                           Alert("Patient1 Alert --- Selling ",Lots," EURUSD @ ",Bid);
                           }
                        }
                     }                             
                     else
                     {
                       Print("Error on the Short Entry: ",GetLastError());
                       PrintErrorValues();
                     }
                   return (0);
               }//ifopenshort
               
               
               
               
               if(OpenLong == true)
                  {
                   // Calculation of the stoploss
                   if((Bid - SellSucPossibilityMid*StopLossIndex- ModeSpread* Point) > 
                      (Bid - ModeStopLevel* ModePoint- ModeSpread* Point))
                     {
                       StopLoss = Bid - ModeStopLevel* ModePoint- ModeSpread* Point - Disperce;
                     }
                   else
                     {
                       if(SellSucPossibilityMid != 0)
                           StopLoss = Bid - SellSucPossibilityMid*StopLossIndex- 
                                      ModeSpread* Point- Disperce;
                       else
                           StopLoss = Bid - ModeStopLevel* ModePoint- ModeSpread* Point- 
                                      Disperce;
                     }
                   if(ManualStopLoss > 0) 
                     {
                     StopLoss = Bid - (ManualStopLoss * Point);
                     }
                   StopLevel = StopLoss;
                   BlockBuy = false;
                   discretion();
                   if(BlockBuy == true)
                     {
                       return(0);
                     }
                   if(UseRunAwayEnterance && SkipRAE == false) //skipRAE is provided for reentries control, initial orders are false, reentries are true     
                    { 
                     if(Ask >= Unow + (RAELevel*Point))//long run away enterance filter
                       {
                       // Print("RAE Blocked Long Entrance @: ", Ask," > RAE: ",Unow + RAELevel*Point,"  Entry: ",Year(),".",Month(),".",Day(),".",Hour(),".",Minute(),".",Seconds());
                        return(0);
                       }
                    }   
                   TSF = TrailingStopFactor;
                   double HH = 0;
                   HH = High[Highest(NULL,0,MODE_HIGH,64,1)];
                  if((Ask + (22*Point) > HH) && ADXnow > ADX1)
                     {
                        if(DIPnow <= 19)
                         {
                         TakeProfit = 50;
                         TrailingStopFactor = 3;
                         StopLoss = Ask - (22*Point);
                         //Print("TakeProfit: ",TakeProfit,"StopLoss: :",StopLoss," TrailingStopFactor: ",TrailingStopFactor);
                         }
                        if(DIPnow > 19 && MAEVP > MAEVP2)
                         {
                         TakeProfit = 220;
                         TrailingStopFactor = 4;
                         }
                         else
                         {
                         TakeProfit = TakeProfit;
                         } 
                     } 
                     else
                     {
                     //Print("Long entry @: ",Ask," blocked by HH ",HH);
                     return(0);
                     }
                     StopLoss = StopLoss - (4*Point); /////////////////////////////////////kludge very messy
                   //---- Open Long Order  
                   ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, SlipPage, StopLoss, Ask + (TakeProfit * Point), "NeuroCluster-testing-AI-LB1", MagicNumber, 0, Blue);
                     if(ticket > 0)
                       {
                        if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
                        {
                           OpenLong=false;
                           SkipRAE = false;
                           if (Usefilewrite)
                           {
                              datetime lorderOpen=OrderOpenTime();
                              handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
                              if(handle!=-1)
                                {
                                    FileSeek(handle,0,SEEK_END);
                                    FileWrite(handle," ");
                                    FileWrite(handle," Opened LONG #: ",OrderTicket()," Order Open Time: ",lorderOpen);
                                    FileWrite(handle,"Lots: ",Lots," Ask: ",Ask," SlipPage: ",SlipPage," StopLoss: ",StopLoss," Take Profit: ",Ask + (TakeProfit * Point)," TrailingStopFactor: ",TrailingStopFactor);
                                    FileWrite(handle,"ADXnow: ",ADXnow," DIPnow: ",DIPnow," DIMnow: ",DIMnow," HH of last 64 bars: ",HH);
                                    FileWrite(handle,"Cnow: ",Cnow," Lnow: ",Lnow," Unow: ",Unow," MAEVP: ",MAEVP," MAEVP2: ",MAEVP2," MA100: ",MA100," MA1002: ",MA1002);
                                    
                                    FileFlush(handle);
	                                 FileClose(handle);
                                }   
                                else
                                 {
                                 int err1;
                                 err1=GetLastError();
                                 Print("error(",err1,"): ",ErrorDescription(err1));

                                 return(0);                     
                                 }
                           }//if use file write
                           Print("LONG OPENED WITH TRAILINGSTOPFACTOR = ",TrailingStopFactor);
                           
                           PrevBuyStop = OrderStopLoss();
                           if(UseAlerts==true)
                             {
                             PlaySound("alert.wav");
                             Alert("Patient1 Alert --- Buying EURUSD ",Lots," EURUSD @ ",Ask);
                             }                        
                         }
                       }
                       else
                       {
                         Print("Error on the Long Entry: ",GetLastError());
                         PrintErrorValues();
                       }
                  return (0);  
                  }//ifopenlong
   }//maxtrades
return (0);
}//entermarket







//+------------------------------------------------------------------+
//| Automatic installation of the level of the stoploss              |
//+------------------------------------------------------------------+

int AutoStopLossIndex()
  {
   if(AutoStopLossIndex == true)
     {
       StopLossIndex = Spread;//ModeSpread
     }
   return(0);
  }
  
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
  
//+------------------------------------------------------------------+
//| Dynamic Trailing Stop                                            |
//+------------------------------------------------------------------+
// Check to see if "EnableTrailingStop" is enabled..if not no need to execute
// Only Modify the "StopLevel" here, since the exits are executed on the next function ExitMarket()
// please make sure that the distance is >= 5 pips from the market, otherwise the stop order modification will be rejected.
// Thank you!
int DynamicTrailStop()
{
    //Print("answer call trailstop");
    if(EnableTrailingStop)
      {
       TrailingStop = (TrailingStopFactor * iATR(Symbol(), 0 , TrailATRPeriod , 1) );
       for(int cnt = 0; cnt < OrdersTotal(); cnt++)
         {
            bool DynamicTrailAllowed = true;
            OrderSelect(cnt, SELECT_BY_POS);
            if(OrderMagicNumber() != MagicNumber)//insures only Patient1 placed orders are dynamic trail stop managed
               {
               DynamicTrailAllowed = False;
               }    
            if(DynamicTrailAllowed && OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && TrailingStop > 0)
               {
               if(OrderType() == OP_BUY)// If order is a long position
                  {
                  BuyStop = Bid - TrailingStop;
                  if(BuyStop < PrevBuyStop) // We maintain the highest value
                     {
                     BuyStop = PrevBuyStop;
                     }
                  if(BuyStop > 0 && (Bid - BuyStop) >= Bid - (5 * Point)  && BuyStop > OrderStopLoss())// if new stop loss is allowed and higher than current stop loss
                     {
                     BuyStop = BuyStop - (4*Point);//////////////////kludge very messy
                     OrderModify(OrderTicket(), OrderOpenPrice(), BuyStop, OrderTakeProfit(), 0);
                     }
                  }
                  else 
                  {
                  if(OrderType() == OP_SELL)// If order is a short position
                     {
                     SellStop = Ask + TrailingStop;
                     if(SellStop > PrevSellStop) // We maintain the lowest value
                        {
                        SellStop = PrevSellStop;
                        }
                     if(SellStop > 0 && (SellStop - Ask) >= Ask + (5 * Point)  && SellStop < OrderStopLoss())// if new stop loss is allowed and lower than current stop loss
                        {
                        SellStop = SellStop + (4*Point);//////////////////kludge very messy
                        OrderModify(OrderTicket(), OrderOpenPrice(), SellStop, OrderTakeProfit(), 0);
                        }
                     }//ifOT=S
                  }//ifOT=B
                           
                  if(OrderType() == OP_BUY)
                  {
                     BuyStop = Bid - TrailingStop;
                     if(BuyStop < PrevBuyStop) BuyStop = PrevBuyStop;
                     if(BuyStop > 0 && (Bid - BuyStop) >= 5 * Point && BuyStop > OrderStopLoss())
                        {
                        OrderModify(OrderTicket(), OrderOpenPrice(), BuyStop, OrderTakeProfit(), 0);
                        }
                  }
                  else 
                  {
                     if(OrderType() == OP_SELL)
                     {
                        SellStop = Ask + TrailingStop;
                        if(SellStop > PrevSellStop) SellStop = PrevSellStop;
                        if(SellStop > 0 && (SellStop - Ask) >= 5 * Point && SellStop < OrderStopLoss())
                           {
                           OrderModify(OrderTicket(), OrderOpenPrice(), SellStop, OrderTakeProfit(), 0);
                           }
                     }
                  }

              }//ifDTA
         PrevBuyStop = BuyStop;
         PrevSellStop = SellStop;
      }//for
   }//ifEnableTS      
return (0);
}//DTS


  
  
  
  
  







//+------------------------------------------------------------------+
//| Exit from the market                                             |
//+------------------------------------------------------------------+

int ExitMarket() // -------------------- Working the open orders -------------------
{
   if(UseExitMarket)
   {
      total = OrdersTotal();
      for(int cnt = 0; cnt < OrdersTotal(); cnt++)
         {
          OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            // We search for orders opened by this code on our currency
            if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)// if this code has an open order on this currency
               {
               //Print("found ticket: ",OrderTicket()," type: ",OrderType()," total open orders: ",cnt);
               if(OrderType()==OP_BUY)  // If the obtained order is by the acquisition of the currency
                  {
                      if(UseStopLossClose)
                        {
                        // We close when we reach stop loss
                        if(Bid-(4*Point) <= OrderStopLoss() )
                           {
                           OrderClose(OrderTicket(), OrderLots(), Bid , SlipPage, Violet); // Close the order                             
                                 if (Usefilewrite)
                                 {  
                                   if(OrderOpenPrice() + Spread < OrderClosePrice()) 
                                    {
                                       datetime s1orderOpen=OrderOpenTime();
                                       handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
                                       if(handle!=-1)
                                         {
                                         FileSeek(handle,0,SEEK_END);
                                         FileWrite(handle,"SL Winning Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",s1orderOpen);
                                         FileWrite(handle,"  ");
                                         FileFlush(handle);
                                         FileClose(handle);
                                         Print("SL Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
                                         }   
                                         else
                                         {
                                         int err11;
                                         err11=GetLastError();
                                         Print("error(",err11,"): ",ErrorDescription(err11));
                                         //return(0);                     
                                         }  
                                    }//if win 
                                    //Print("SL Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid); 
  
                                    if(OrderOpenPrice() + Spread >= OrderClosePrice())
                                       {  
                                       datetime s2lorderOpen=OrderOpenTime();
                                       handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
                                       if(handle!=-1)
                                         {
                                         FileSeek(handle,0,SEEK_END);
                                         FileWrite(handle,"SL Losing Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",s2lorderOpen);
                                         FileWrite(handle,"  ");
                                         FileFlush(handle);
                                         FileClose(handle);
                                         Print("SL Recorded Losing Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
                                         }   
                                         else
                                         {
                                         int err14;
                                         err14=GetLastError();
                                         Print("error(",err14,"): ",ErrorDescription(err14));
                                         return(0);                     
                                         }  
                                       }//if lose 
                                       //Print("SL Recorded Losing Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);   
                                 }//if use file write
                           TrailingStopFactor = TSF;
                           //Print("Patient1 closed SL long ticket ",OrderTicket()," on a MA Dev. @: ",Bid," BECAUSE cls: ",EMAm1," > MAEVP: ",MAEVP);
                           /*
                           }
                           else
                           {
                           Print("stays open");
                           int er2r;
                           er2r=GetLastError();
                           Print("error(",er2r,"): ",ErrorDescription(er2r));
                           */
                           return(0);
                           }
                        }
                        
                        if(UseEnhancedTP)
                        {
                        // We close when we reach take profit level
                        double Cls = iClose(NULL,PERIOD_M1,0);
                        double ETPL = Cls+(Point*ReenterTPgap);
                        double ETPL1 = Cls+(Point*(ReenterTPgap+1));
                        double ETPL2 = Cls+(Point*(ReenterTPgap+2));
                        double ETPL3 = Cls+(Point*(ReenterTPgap+3));
                        double otp = OrderTakeProfit();
                        if((ETPL || ETPL1 || ETPL2 || ETPL3) >= otp)
                           {
                           OrderClose(OrderTicket(), OrderLots(), Bid , SlipPage, Violet); // Close the order                            
if (Usefilewrite)
{  
   if(OrderOpenPrice() + Spread < OrderClosePrice())
   {   
      datetime borderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Winning Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",borderOpen);
        FileWrite(handle,"  ");
        
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
        }   
        else
        {
        int err;
        err=GetLastError();
        Print("error(",err,"): ",ErrorDescription(err));
        //return(0);                     
        } 
     }//if win
     Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);     

   if(OrderOpenPrice() + Spread >= OrderClosePrice())
   {
      datetime blorderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Losing Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",blorderOpen);
        FileWrite(handle,"  ");
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Losing Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
       
        }   
        else
        {
        int err1;
        err1=GetLastError();
        Print("error(",err1,"): ",ErrorDescription(err1));
        return(0);                     
        } 
    }//if lose  
}//if use file write 

                           TrailingStopFactor = TSF;
                           Print("Patient1 closed long ticket ",OrderTicket()," on Take Profit @: ",Bid," BECAUSE ETPL: ",ETPL," or ETPL1: ",ETPL1," or ETPL2: ",ETPL2," or ETPL3: ",ETPL3, " >= take profit: ",OrderTakeProfit());
                           if(UseReenter == true)
                              {
                              if(DIPnow > DIplus1 || ADXnow > ADX1)
                                 {
                                 OpenLong = true;
                                 SkipRAE = true;
                                 Print("re-entering Long @: ",Ask);
                                 EnterMarket();
                                 return(0);
                                 }   
                              }
                          /* }
                           else
                           {
                           Print("stays open");
                           int er1r;
                           er1r=GetLastError();
                           Print("error(",er1r,"): ",ErrorDescription(er1r));
                           */
                           return(0);                     
                           }
                        }
                     
                     if(UseDevStop)
                        {
                        // We close when we approach opposite entry point
                        if(EMAm1 < MAEVP)
                           {
                           OrderClose(OrderTicket(), OrderLots(), Bid , SlipPage, Violet); // Close the order                            
if (Usefilewrite)
{  
   if(OrderOpenPrice() + Spread < OrderClosePrice())
   {   
      datetime b1orderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Winning Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",b1orderOpen);
        FileWrite(handle,"  ");
        
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
        }   
        else
        {
        int err7;
        err7=GetLastError();
        Print("error(",err7,"): ",ErrorDescription(err7));
        //return(0);                     
        } 
     }//if win
     Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);     

   if(OrderOpenPrice() + Spread >= OrderClosePrice())
   {
      datetime b5lorderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Losing Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",b5lorderOpen);
        FileWrite(handle,"  ");
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Losing Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
       
        }   
        else
        {
        int err91;
        err91=GetLastError();
        Print("error(",err91,"): ",ErrorDescription(err91));
        return(0);                     
        } 
    }//if lose  
}//if use file write 

                           Print("Patient1 closed long ticket ",OrderTicket()," on a MA Dev. @: ",Bid," BECAUSE cls: ",EMAm1," < MAEVP: ",MAEVP);
                           TrailingStopFactor = TSF;
                          /* }
                           else
                           {
                           Print("stays open");
                           int er1r;
                           er1r=GetLastError();
                           Print("error(",er1r,"): ",ErrorDescription(er1r));
                           */
                           return(0);                     
                           }
                        }
                     
                     if(UseRevEnvelop)
                        {
                        // We close when the direction reverses
                        if(EMAm1 < UpperEc)
                           {
                           OrderClose(OrderTicket(), OrderLots(), Bid , SlipPage, Violet); // Close the order                            
if (Usefilewrite)
{  
   if(OrderOpenPrice() + Spread < OrderClosePrice())
   {   
      datetime b8orderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Winning Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",b8orderOpen);
        FileWrite(handle,"  ");
        
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
        }   
        else
        {
        int err88;
        err88=GetLastError();
        Print("error(",err88,"): ",ErrorDescription(err88));
        //return(0);                     
        } 
     }//if win
     Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);     

   if(OrderOpenPrice() + Spread >= OrderClosePrice())
   {
      datetime b74lorderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Losing Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",b74lorderOpen);
        FileWrite(handle,"  ");
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Losing Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
       
        }   
        else
        {
        int err174;
        err174=GetLastError();
        Print("error(",err174,"): ",ErrorDescription(err174));
        return(0);                     
        } 
    }//if lose  
}//if use file write 

                           Print("Patient1 closed long ticket ",OrderTicket()," on a reverse @: ",Bid," BECAUSE cls: ",EMAm1," < uprE: ",UpperEc);
                           TrailingStopFactor = TSF;
                           /*
                           }
                           else
                           {
                           Print("stays open");
                           int err;
                           err=GetLastError();
                           Print("error(",err,"): ",ErrorDescription(err));
                           */
                           return(0);                     
                           }
                        }   
                    if(UseRevADX)
                        {
                        if(ADX < ADX1 && DIminus > DIminus1)
                           {
                           OrderClose(OrderTicket(), OrderLots(), Bid , SlipPage, Violet); // Close the order                            
                           Print("Patient1 closed long ticket ",OrderTicket()," on a reverse @: ",Bid," BECAUSE ADX: ",ADX," < ADX1: ",ADX1," && DI-: ",DIminus," > DI-(1): ",DIminus1);
if (Usefilewrite)
{  
   if(OrderOpenPrice() + Spread < OrderClosePrice())
   {   
      datetime b76orderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Winning Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",b76orderOpen);
        FileWrite(handle,"  ");
        
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
        }   
        else
        {
        int err76;
        err76=GetLastError();
        Print("error(",err76,"): ",ErrorDescription(err76));
        //return(0);                     
        } 
     }//if win
     Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);     

   if(OrderOpenPrice() + Spread >= OrderClosePrice())
   {
      datetime b78lorderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Losing Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",b78lorderOpen);
        FileWrite(handle,"  ");
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Losing Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
       
        }   
        else
        {
        int err187;
        err187=GetLastError();
        Print("error(",err187,"): ",ErrorDescription(err187));
        return(0);                     
        } 
    }//if lose  
}//if use file write 

                           TrailingStopFactor = TSF;
                           /*
                           }
                           else
                           {
                           Print("stays open");
                           int err2;
                           err2=GetLastError();
                           Print("error(",err2,"): ",ErrorDescription(err2));
                           */
                           return(0);
                           } 
                        }     
                  }//ifbuy
                  
                  
                  
                  
                  
                  
                  
                  
             
               if(OrderType() == OP_SELL)  // If the obtained order is by the selling of the currency
                  {
                     if(UseStopLossClose)
                        {
                        // We close when we reach stop loss
                        if(Ask+(2*Point) >= OrderStopLoss() )
                           {
                           OrderClose(OrderTicket(), OrderLots(), Ask , SlipPage, Violet); // Close the order                             
                                 if (Usefilewrite)
                                 {  
                                   if(OrderOpenPrice() - Spread > OrderClosePrice()) 
                                    {
                                       datetime s991orderOpen=OrderOpenTime();
                                       handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
                                       if(handle!=-1)
                                         {
                                         FileSeek(handle,0,SEEK_END);
                                         FileWrite(handle,"SL Winning Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",s991orderOpen);
                                         FileWrite(handle,"  ");
                                         FileFlush(handle);
                                         FileClose(handle);
                                         Print("Recorded SL Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);
                                         }   
                                         else
                                         {
                                         int err911;
                                         err911=GetLastError();
                                         Print("error(",err911,"): ",ErrorDescription(err911));
                                         //return(0);                     
                                         }  
                                    }//if win 
                                    //Print("Recorded SL Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask); 
  
                                    if(OrderOpenPrice() - Spread <= OrderClosePrice())
                                       {  
                                       datetime s2l78orderOpen=OrderOpenTime();
                                       handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
                                       if(handle!=-1)
                                         {
                                         FileSeek(handle,0,SEEK_END);
                                         FileWrite(handle,"SL Losing Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",s2l78orderOpen);
                                         FileWrite(handle,"  ");
                                         FileFlush(handle);
                                         FileClose(handle);
                                         Print("SL Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);
                                         }   
                                         else
                                         {
                                         int err1478;
                                         err1478=GetLastError();
                                         Print("error(",err1478,"): ",ErrorDescription(err1478));
                                         return(0);                     
                                         }  
                                       }//if lose 
                                       //Print("SL Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);   
                                 }//if use file write
                           TrailingStopFactor = TSF;
                           //Print("Patient1 closed SL short ticket ",OrderTicket()," on a MA Dev. @: ",Ask," BECAUSE cls: ",EMAm1," > MAEVP: ",MAEVP);
                           /*
                           }
                           else
                           {
                           Print("stays open");
                           int er2r;
                           er2r=GetLastError();
                           Print("error(",er2r,"): ",ErrorDescription(er2r));
                           */
                           return(0);
                           }
                        }
                        
                        if(UseEnhancedTP)
                        {
                        // We close when we reach take profit level
                        double ETPS = EMAm1-(Point*ReenterTPgap);
                        if(ETPS <= OrderTakeProfit())//iClose(NULL,PERIOD_M1,0)
                           {
                           OrderClose(OrderTicket(), OrderLots(), Ask , SlipPage, Violet); // Close the order                            
if (Usefilewrite)
{  
  if(OrderOpenPrice() - Spread > OrderClosePrice()) 
   {
      datetime sorderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Winning Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",sorderOpen);
        FileWrite(handle,"  ");
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);
        }   
        else
        {
        int err3;
        err3=GetLastError();
        Print("error(",err3,"): ",ErrorDescription(err3));
        //return(0);                     
        }  
   }//if win 
   //Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask); 
  
   if(OrderOpenPrice() - Spread <= OrderClosePrice())
      {  
      datetime slorderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Losing Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",slorderOpen);
        FileWrite(handle,"  ");
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);
        }   
        else
        {
        int err4;
        err4=GetLastError();
        Print("error(",err4,"): ",ErrorDescription(err4));
        return(0);                     
        }  
      }//if lose 
      //Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);   
}//if use file write
                           TrailingStopFactor = TSF;
                           Print("Patient1 closed short ticket ",OrderTicket()," on Take Profit @: ",Ask," BECAUSE ETPS: ",ETPS," <= take profit: ",OrderTakeProfit());
                           if(UseReenter == true)
                              {
                              if(MAEVP < MAEVP2)
                                 {
                                 if((ADXnow < ADX1) || DIMnow > DIminus1)
                                    {
                                    OpenShort = true;
                                    SkipRAE = true;
                                    Print("re-entering Short @: ",Bid);
                                    EnterMarket();
                                    return(0);
                                    }   
                                 }
                              }
                          /* }
                           else
                           {
                           Print("stays open");
                           int er1r;
                           er1r=GetLastError();
                           Print("error(",er1r,"): ",ErrorDescription(er1r));
                           */
                           return(0);                     
                           }
                        }
                        
                        if(UseDevStop)
                        {
                        // We close when we approach opposite entry point
                        if(EMAm1 > MAEVP )
                           {
                           OrderClose(OrderTicket(), OrderLots(), Ask , SlipPage, Violet); // Close the order                             
                                 if (Usefilewrite)
                                 {  
                                   if(OrderOpenPrice() - Spread > OrderClosePrice()) 
                                    {
                                       datetime s122orderOpen=OrderOpenTime();
                                       handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
                                       if(handle!=-1)
                                         {
                                         FileSeek(handle,0,SEEK_END);
                                         FileWrite(handle,"Winning Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",s122orderOpen);
                                         FileWrite(handle,"  ");
                                         FileFlush(handle);
                                         FileClose(handle);
                                         Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ",Ask);
                                         }   
                                         else
                                         {
                                         int err112;
                                         err112=GetLastError();
                                         Print("error(",err112,"): ",ErrorDescription(err112));
                                         //return(0);                     
                                         }  
                                    }//if win 
                                    //Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask); 
  
                                    if(OrderOpenPrice() - Spread <= OrderClosePrice())
                                       {  
                                       datetime s2l8orderOpen=OrderOpenTime();
                                       handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
                                       if(handle!=-1)
                                         {
                                         FileSeek(handle,0,SEEK_END);
                                         FileWrite(handle,"Losing Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",s2l8orderOpen);
                                         FileWrite(handle,"  ");
                                         FileFlush(handle);
                                         FileClose(handle);
                                         Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);
                                         }   
                                         else
                                         {
                                         int err148;
                                         err148=GetLastError();
                                         Print("error(",err148,"): ",ErrorDescription(err148));
                                         return(0);                     
                                         }  
                                       }//if lose 
                                       //Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);   
                                 }//if use file write
                           TrailingStopFactor = TSF;
                           Print("Patient1 closed short ticket ",OrderTicket()," on a MA Dev. @: ",Ask," BECAUSE cls: ",EMAm1," > MAEVP: ",MAEVP);
                           /*
                           }
                           else
                           {
                           Print("stays open");
                           int er2r;
                           er2r=GetLastError();
                           Print("error(",er2r,"): ",ErrorDescription(er2r));
                           */
                           return(0);
                           }
                        }
                     
                     if(UseRevEnvelop)
                        {
                        // We close when the direction reverses
                        if(EMAm1 > LowerEc)
                           {
                           OrderClose(OrderTicket(), OrderLots(), Ask , SlipPage, Violet); // Close the order                             
if (Usefilewrite)
{  
  if(OrderOpenPrice() - Spread > OrderClosePrice()) 
   {
      datetime s3orderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Winning Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",s3orderOpen);
        FileWrite(handle,"  ");
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);
        }   
        else
        {
        int err23;
        err23=GetLastError();
        Print("error(",err23,"): ",ErrorDescription(err23));
        //return(0);                     
        }  
   }//if win 
   //Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask); 
  
   if(OrderOpenPrice() - Spread <= OrderClosePrice())
      {  
      datetime s3lorderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Losing Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",s3lorderOpen);
        FileWrite(handle,"  ");
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);
        }   
        else
        {
        int err34;
        err34=GetLastError();
        Print("error(",err34,"): ",ErrorDescription(err34));
        return(0);                     
        }  
      }//if lose 
      //Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);   
}//if use file write
                           Print("Patient1 closed short ticket ",OrderTicket()," on a reverse @: ",Ask," BECAUSE cls: ",EMAm1," > lwrEc: ",LowerEc);
                           TrailingStopFactor = TSF;
                           /*
                           }
                           else
                           {
                           Print("stays open");
                           int err3;
                           err3=GetLastError();
                           Print("error(",err3,"): ",ErrorDescription(err3));
                           */
                           return(0);
                           }
                        }   
                     if(UseRevADX)
                        {
                        if(ADX < ADX1 && DIplus > DIplus1)
                           {
                           OrderClose(OrderTicket(), OrderLots(), Ask , SlipPage, Violet); // Close the order                             
if (Usefilewrite)
{  
  if(OrderOpenPrice() - Spread > OrderClosePrice()) 
   {
      datetime s4orderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Winning Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",s4orderOpen);
        FileWrite(handle,"  ");
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);
        }   
        else
        {
        int err43;
        err43=GetLastError();
        Print("error(",err43,"): ",ErrorDescription(err43));
        //return(0);                     
        }  
   }//if win 
   //Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask); 
  
   if(OrderOpenPrice() - Spread <= OrderClosePrice())
      {  
      datetime s5lorderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Losing Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",s5lorderOpen);
        FileWrite(handle,"  ");
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);
        }   
        else
        {
        int err54;
        err54=GetLastError();
        Print("error(",err54,"): ",ErrorDescription(err54));
        return(0);                     
        }  
      }//if lose 
      //Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);   
}//if use file write
                           Print("Patient1 closed short ticket ",OrderTicket()," on a reverse @: ",Ask," BECAUSE ADX: ",ADX," < ADX1: ",ADX1,"  && DI+: ",DIplus," > DI+(1): ",DIplus1);
                           TrailingStopFactor = TSF;
                           /*
                           }
                           else
                           {
                           Print("stays open");
                           int err4;
                           err4=GetLastError();
                           Print("error(",err4,"): ",ErrorDescription(err4));
                           */
                           return(0);
                           }
                        }//userevadx   
                  }//ifsell   
               }//if order is open  
         }//fororders 
   }         
return(0);        
}//exitmarket  
 
 
 
//+------------------------------------------------------------------+
//| Conclusion of errors with the entrance into the market           |
//+------------------------------------------------------------------+

int PrintErrorValues()
  {
   Print("ErrorValues:Symbol=", Symbol(),",Lots=",Lots, ",Bid=", Bid, ",Ask=", Ask,
         ",SlipPage=", SlipPage, "StopLoss=",StopLoss,",TakeProfit=", TakeProfit, "tp * point= ",(TakeProfit*Point));
   return (0);
  }  
  
  
  
  
  
//////the next 3 functions are combined with the init. and spread calculation to assign stop loss
//+------------------------------------------------------------------+
//| We make the decision    --used to assign stop loss                                           |
//+------------------------------------------------------------------+

int CalculatePossibility (int shift)
  {
   DecisionValue = iClose( Symbol(), 0, ValuePeriod * shift) - 
                   iOpen( Symbol(), 0, ValuePeriod * shift);
   PrevDecisionValue = iClose( Symbol(), 0, ValuePeriod * (shift+1)) - 
                       iOpen( Symbol(), 0, ValuePeriod * (shift+1));
   SellPossibility = 0;
   BuyPossibility = 0;
   UndefinedPossibility = 0;
   if(DecisionValue != 0)                                         // If the solution not definite
     {
       if(DecisionValue > 0)  //means current bar closed up       // If the solution in favor of sale
         {
                                                                  // Suspicion to the probability of sale
           if(PrevDecisionValue < 0)//means previous bar closed down   // Confirmation of the solution in favor of sale
             {
               Decision = DECISION_SELL;
               BuyPossibility = 0;
               SellPossibility = DecisionValue;
               UndefinedPossibility = 0;
             }
           else                                                   // Otherwise the solution is not determined
             {
               Decision = DECISION_UNKNOWN;
               UndefinedPossibility = DecisionValue;
               BuyPossibility = 0;
               SellPossibility = 0;
             }
         }
       else  //means current bar closed down                      // If the solution in favor of the purchase
         {
           if(PrevDecisionValue > 0) //means previous bar closed up// Confirmation of the solution in favor of buy
             {
               Decision = DECISION_BUY;
               SellPossibility = 0;
               UndefinedPossibility = 0;
               BuyPossibility = -1 * DecisionValue;
             }
           else                                                   // The solution is not determined
             {
               Decision = DECISION_UNKNOWN;
               UndefinedPossibility = -1 * DecisionValue;
               SellPossibility = 0;
               BuyPossibility = 0;
             }
         }
     }
   else
     {
       Decision = DECISION_UNKNOWN;
       UndefinedPossibility = 0;
       SellPossibility = 0;
       BuyPossibility = 0;
     }
   return (Decision);
  }
  

//+------------------------------------------------------------------+
//| We calculate the statistics of the probabilities      --used to assign stop loss                            |
//+------------------------------------------------------------------+

int CalculatePossibilityStat()
  {
   int i;
   BuySucPossibilityCount = 0;
   SellSucPossibilityCount = 0;
   UndefinedSucPossibilityCount = 0;
//----
   BuyPossibilityCount = 0;
   SellPossibilityCount = 0;
   UndefinedPossibilityCount = 0;
// We calculate the average values of the probability
   BuySucPossibilityMid = 0;
   SellSucPossibilityMid = 0;
   UndefinedSucPossibilityMid = 0;
   BuyPossibilityQuality = 0;
   SellPossibilityQuality = 0;
   UndefinedPossibilityQuality = 0;
   PossibilityQuality = 0;
//----
   BuySucPossibilityQuality = 0;
   SellSucPossibilityQuality = 0;
   UndefinedSucPossibilityQuality = 0;
   PossibilitySucQuality = 0;
   for( i = 0 ; i < ModelingBars ; i ++ )
     {
       // We calculate the solution for this interval
       CalculatePossibility (i);
       // If the solution for value of i - was sold         
       if(Decision == DECISION_SELL )
           SellPossibilityQuality ++;   //means count of sell signals in modeling period        
       // If the solution for value of i - was bought
       if(Decision == DECISION_BUY )
           BuyPossibilityQuality ++;    //means count of buy signals in modeling period       
       // If the solution for value of i - is not determined
       if(Decision == DECISION_UNKNOWN )
           UndefinedPossibilityQuality ++;   //means count of unknown signals in modeling period        
       // The same estimations for the successful situations                 
       //
       if((BuyPossibility > Spread) || (SellPossibility > Spread) || 
          (UndefinedPossibility > Spread))   //means we have more market activity than spread 
         {
           if(Decision == DECISION_SELL)
               SellSucPossibilityQuality ++;        //means more market activity toward selling in modeling period             
           if(Decision == DECISION_BUY)
               BuySucPossibilityQuality ++;        //means more market activity toward buying in modeling period
           if(Decision == DECISION_UNKNOWN )
               UndefinedSucPossibilityQuality ++;      //means more unknown market activity in modeling period             
         }  
       // We calculate the average probabilities of the events
       // Probabilities of the purchase
       BuyPossibilityMid *= BuyPossibilityCount;//starts @ 0,0
       BuyPossibilityCount ++;      //adds 1 for each modeling period
       BuyPossibilityMid += BuyPossibility;//adds 0 to BP returns market activity unchanged
       if(BuyPossibilityCount != 0 )//condition is always positive as long as modeling 1 != 0
           BuyPossibilityMid /= BuyPossibilityCount; ///divisor = number of modeling passes    0 / passes always returns 0
       else                                           //repeats above logic for sell
           BuyPossibilityMid = 0;
       //  
       SellPossibilityMid *= SellPossibilityCount;
       SellPossibilityCount ++;
       SellPossibilityMid += SellPossibility;
       if(SellPossibilityCount != 0 )
           SellPossibilityMid /= SellPossibilityCount;
       else                                                    //repeats above logic for unknowns
           SellPossibilityMid = 0;
       // Probabilities of the indeterminate state
       UndefinedPossibilityMid *= UndefinedPossibilityCount;
       UndefinedPossibilityCount ++;
       UndefinedPossibilityMid += UndefinedPossibility;
       if(UndefinedPossibilityCount != 0)
           UndefinedPossibilityMid /= UndefinedPossibilityCount;
       else
           UndefinedPossibilityMid = 0;
       // We calculate the average probabilities of the successful events
       if(BuyPossibility > Spread)                        
         {
           BuySucPossibilityMid *= BuySucPossibilityCount;
           BuySucPossibilityCount ++;
           BuySucPossibilityMid += BuyPossibility;
           if(BuySucPossibilityCount != 0)
               BuySucPossibilityMid /= BuySucPossibilityCount;
           else
               BuySucPossibilityMid = 0;
         }
       if(SellPossibility > Spread)
         {
           SellSucPossibilityMid *= SellSucPossibilityCount;
           SellSucPossibilityCount ++;                 
           SellSucPossibilityMid += SellPossibility;
           if (SellSucPossibilityCount != 0)
              SellSucPossibilityMid /= SellSucPossibilityCount;
              else
                 SellSucPossibilityMid = 0;
         }
       if(UndefinedPossibility > Spread)
         {
           UndefinedSucPossibilityMid *= UndefinedSucPossibilityCount;
           UndefinedSucPossibilityCount ++;                 
           UndefinedSucPossibilityMid += UndefinedPossibility;
           if(UndefinedSucPossibilityCount != 0)
               UndefinedSucPossibilityMid /= UndefinedSucPossibilityCount;
           else
               UndefinedSucPossibilityMid = 0;
         }
     }
   if((UndefinedPossibilityQuality + SellPossibilityQuality + BuyPossibilityQuality)!= 0)
       PossibilityQuality = (SellPossibilityQuality + BuyPossibilityQuality) / 
       (UndefinedPossibilityQuality + SellPossibilityQuality + BuyPossibilityQuality);
   else             
       PossibilityQuality = 0;
   //    
   if((UndefinedSucPossibilityQuality + SellSucPossibilityQuality + 
      BuySucPossibilityQuality)!= 0)          
       PossibilitySucQuality = (SellSucPossibilityQuality + BuySucPossibilityQuality) / 
                                (UndefinedSucPossibilityQuality + SellSucPossibilityQuality + 
                                BuySucPossibilityQuality);
   else             
       PossibilitySucQuality = 0;
   return (0);
  }
  
//+------------------------------------------------------------------+
//|  We analyze state for decision making          --used to assign stop loss                    |
//+------------------------------------------------------------------+

int Patient1Decision()
  {
// We calculate the statistics of the period
   CalculatePossibilityStat();
// We calculate the probabilities of the accomplishment of the transactions
   CalculatePossibility(0);
   return(Decision);     
  }  
  
//+------------------------------------------------------------------+
//|  We analyze relevant discretionary conditions                    |
//+------------------------------------------------------------------+
void discretion()
{
   if(UseDiscretion)
      {
         if(OpenLong)
         {
         if(iMA(NULL,0,MajorTrendAveragingPeriod,0,MODE_LWMA,0,0) < iMA(NULL,0,MajorTrendAveragingPeriod,0,MODE_LWMA,0,2))// is signal counter trend?
            {
            BlockBuy = true;
            Print("Blocked Long by countertrend filter");
            }//ifcountertrend
         }//if openlong
 
         if(OpenShort)
         {
         if(iMA(NULL,0,MajorTrendAveragingPeriod,0,MODE_LWMA,0,0) > iMA(NULL,0,MajorTrendAveragingPeriod,0,MODE_LWMA,0,2))// is signal counter trend?
            {
            BlockSell = true;
            Print("Blocked Short by countertrend filter");
            }//ifcountertrend
         }//if openshort 
      }//usediscretion    
}//discretion


/////////////////////the hard reverser/////////
void HardReverser()
{
   if(UseHardReverser == true)
      {    
      if(FoundOpenedOrder == True)
         {
         total = OrdersTotal();
         for(int cnt = 0; cnt < OrdersTotal(); cnt++)
            {
             OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
               // We search for orders opened by this code on our currency
               if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)// if this code has an open order on this currency
                  {
                  if(OrderType()==OP_BUY)  // If the obtained order is by the acquisition of the currency
                     {
                     if(OpenShort == true)
                        {
                        OrderClose(OrderTicket(), OrderLots(), Bid , SlipPage, Violet); // Close the order                            
if (Usefilewrite)
{  
   if(OrderOpenPrice() + Spread < OrderClosePrice())
   {   
      datetime borderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Winning Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",borderOpen);
        FileWrite(handle,"  ");
        
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
        }   
        else
        {
        int err;
        err=GetLastError();
        Print("error(",err,"): ",ErrorDescription(err));
        //return(0);                     
        } 
     }//if win
     Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);     

   if(OrderOpenPrice() + Spread >= OrderClosePrice())
   {
      datetime blorderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Losing Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",blorderOpen);
        FileWrite(handle,"  ");
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Losing Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
       
        }   
        else
        {
        int err1;
        err1=GetLastError();
        Print("error(",err1,"): ",ErrorDescription(err1));
        return(0);                     
        } 
    }//if lose  
}//if use file write 
                        Print("Patient1 closed long ticket ",OrderTicket()," on a Hard Reverse @: ",Bid," >>>>>>> NOW OPENING SHORT");
                        FoundOpenedOrder = false;
                        return (0);
                        }       
                     }//ifbuy
                  if(OrderType()==OP_SELL)  // If the obtained order is by the acquisition of the currency
                     {
                     if(OpenLong == true)
                        {
                        OrderClose(OrderTicket(), OrderLots(), Ask , SlipPage, Violet); // Close the order                            
if (Usefilewrite)
{  
  if(OrderOpenPrice() - Spread > OrderClosePrice()) 
   {
      datetime sorderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Winning Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",sorderOpen);
        FileWrite(handle,"  ");
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
        }   
        else
        {
        int err3;
        err3=GetLastError();
        Print("error(",err3,"): ",ErrorDescription(err3));
        //return(0);                     
        }  
   }//if win 
   //Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid); 
  
   if(OrderOpenPrice() - Spread <= OrderClosePrice())
      {  
      datetime slorderOpen=OrderOpenTime();
      handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
      if(handle!=-1)
        {
        FileSeek(handle,0,SEEK_END);
        FileWrite(handle,"Losing Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",slorderOpen);
        FileWrite(handle,"  ");
        FileFlush(handle);
        FileClose(handle);
        Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
        }   
        else
        {
        int err4;
        err4=GetLastError();
        Print("error(",err4,"): ",ErrorDescription(err4));
        return(0);                     
        }  
      }//if lose 
      //Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);   
}//if use file write
                        Print("Patient1 closed short ticket ",OrderTicket()," on a Hard Reverse @: ",Ask," >>>>>>> NOW OPENING LONG");
                        FoundOpenedOrder = false;
                        return (0);
                        }       
                     }//ifsell   
                  }//ifsymbolandmagic#   
            }//fortotalcounter
         }//foundopenorder
      return(0);
   }//ifusehardreverser   
}//hardreverser
/*
/////////////record outcomes////////////by Aaragorn///////////
void RecordLongOutcomes()
{
   //OrderSelect(OrderTicket(),SELECT_BY_POS,MODE_TRADES);
   if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
      if(OrderType()==OP_BUY)
         {
         if (Usefilewrite)
            {  
               if(OrderOpenPrice() + Spread < OrderClosePrice())
               {   
                  datetime borderOpen=OrderOpenTime();
                  handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Winning Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",borderOpen);
                    FileWrite(handle,"  ");
                    
                    FileFlush(handle);
	                 FileClose(handle);
	                 Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
	                 }   
                    else
                    {
                    int err;
                    err=GetLastError();
                    Print("error(",err,"): ",ErrorDescription(err));
                    //return(0);                     
                    } 
                 }//if win
                 Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);     

               if(OrderOpenPrice() + Spread >= OrderClosePrice())
               {
                  datetime blorderOpen=OrderOpenTime();
                  handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Losing Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",blorderOpen);
                    FileWrite(handle,"  ");
                    FileFlush(handle);
	                 FileClose(handle);
	                 Print("Recorded Losing Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
                   
	                 }   
                    else
                    {
                    int err1;
                    err1=GetLastError();
                    Print("error(",err1,"): ",ErrorDescription(err1));
                    return(0);                     
                    } 
                }//if lose  
            }//if use file write  
         }//if buy
      }//if symbol and magic number   
   return (0);
}//record long winner outcomes

void RecordShortOutcomes()
{
   //OrderSelect(OrderTicket(),SELECT_BY_POS,MODE_TRADES);
   if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
      if(OrderType()==OP_SELL)
         {
         if (Usefilewrite)
            {  
              if(OrderOpenPrice() - Spread > OrderClosePrice()) 
               {
                  datetime sorderOpen=OrderOpenTime();
                  handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Winning Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",sorderOpen);
                    FileWrite(handle,"  ");
                    FileFlush(handle);
	                 FileClose(handle);
                    Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
                    }   
                    else
                    {
                    int err3;
                    err3=GetLastError();
                    Print("error(",err3,"): ",ErrorDescription(err3));
                    //return(0);                     
                    }  
               }//if win 
               //Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid); 
              
               if(OrderOpenPrice() - Spread <= OrderClosePrice())
                  {  
                  datetime slorderOpen=OrderOpenTime();
                  handle = FileOpen("Patient4.txt",FILE_READ|FILE_WRITE);
                  if(handle!=-1)
                    {
                    FileSeek(handle,0,SEEK_END);
                    FileWrite(handle,"Losing Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",slorderOpen);
                    FileWrite(handle,"  ");
                    FileFlush(handle);
	                 FileClose(handle);
                    Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
                    }   
                    else
                    {
                    int err4;
                    err4=GetLastError();
                    Print("error(",err4,"): ",ErrorDescription(err4));
                    return(0);                     
                    }  
                  }//if lose 
                  //Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);   
            }//if use file write
         }//if sell 
      }//if symbol and magic number   
   return (0);
}//record short winner outcomes




*/

/////////////end of record outcomes////////////by Aaragorn///////////